#!/usr/bin/python
# -*- coding: utf-8 -*-

# Copyright (C) 2008 by Kaisermart <pinciaes@yahoo.es>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

''' Standart Python Modules '''
import os
import sys
import array
import fcntl
import socket
import struct
import kdeui
import kfile
import kdecore
''' Import Gettext Support '''
import gettext
__trans = gettext.translation('PyKDESystray', fallback=True)
_  =  __trans.ugettext

''' PyQt and PyKDE Modules'''
from qt import QToolTip, QTimer, QMessageBox, SIGNAL, QEvent, QApplication, QPushButton
from kdecore import KIcon, KIconLoader, KCmdLineArgs, KAboutData, KUniqueApplication, KStandardDirs, KGlobal
from kdeui import KSystemTray, KPopupMenu, KPassivePopup
from dcopexport import DCOPExObj

ficheroconf = '.PyKDESystray'
a = 0
i = 0
p = ''
if ( os.path.exists(ficheroconf) == False ):
    print "Archivo de configuracion no existe"
    f = open(ficheroconf, 'w')
    f.write('0')
    f.close()
    print "Generado archivo de configuracion"
else:
    print "Archivo de configuracion Existe"
    a = int(file(os.path.join(ficheroconf)).readline().strip())

def archivoconfiguracion(c):
    f = open(ficheroconf, 'w')
    f.write(str(c))
    f.close()

class WirelessStatus:

    ''' Signals '''
    SIOCGIWESSID = 0x8B1B # Get ESSID
    SIOCGIWMODE = 0x8B07  # Get Mode
    SIOCGIWRATE = 0x8B21  # Get Rate
    ''' Wireless Constans '''
    wKILO = 10**3
    wMEGA = 10**6
    wGIGA = 10**9

    ''' Byte constants '''
    bKILO = 2**10
    bMEGA = 2**20
    bGIGA = 2**30

    modes = ['Auto', 'Ad-Hoc', 'Managed', 'Master', 'Repeat', 'Second', 'Monitor']

    def __init__(self):
        ''' Constuctor '''
        self.class_path = '/sys/class/net'
        self.device = self.findWirelessInterface()
        self.sockfd = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        if not self.device:
            QMessageBox.information(None, _("No tiene interfaz Wireless"), _("Usted no posee ninguna interfaz Wireless..."), QMessageBox.Ok)
            sys.exit(1)
        
    def findWirelessInterface(self):
        ''' Finds wireless interface '''
        fileName = 'wireless'
        for interface in os.listdir(self.class_path):
            if os.path.exists(os.path.join(self.class_path, interface, fileName)):
                return interface

    def returnInterfaceStatus(self):
        fileName = 'carrier'
        try:
            self.status = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        except IOError:
            return 0
        return self.status

    def returnInterfaceName(self):
        ''' Returns the wireless interface name '''
        return self.device

    def returnLinkStatus(self):
        ''' Returns wireless link status % '''
        fileName = 'wireless/link'
        self.link = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        return int(self.link)

    def changeMode(self):
        global a
        a = a + 1
        if (a == 4):
            a = 0
        archivoconfiguracion(a)
        return int(a)

    def returnNoiseStatus(self):
        ''' Returns current noise level '''
        fileName = 'wireless/noise'
        self.noise = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        return int(self.noise) - 256
    
    def returnSignalStatus(self):
        ''' Returns current signal level '''
        fileName = 'wireless/level'
        self.signal = file(os.path.join(self.class_path, self.device, fileName)).readline().strip()
        return int(self.signal) - 256
     
    def returnReceived(self):
        ''' Returns received bytes '''
        fileName = 'statistics/rx_bytes'
        self.rx = int(file(os.path.join(self.class_path, self.device, fileName)).readline().strip())
 
        if self.rx >= self.bGIGA:
            return "%i Gb" %(self.rx/self.bGIGA)

        if self.rx >= self.bMEGA:
            return "%i Mb" %(self.rx/self.bMEGA)

        return "%i Kb" %(self.rx/self.bKILO)

    def returnTransferred(self):
        ''' Returns transferred bytes '''
        fileName = 'statistics/tx_bytes'
        self.tx = int(file(os.path.join(self.class_path, self.device, fileName)).readline().strip())
 
        if self.tx >= self.bGIGA:
            return "%i Gb" %(self.tx/self.bGIGA)

        if self.tx >= self.bMEGA:
            return "%i Mb" %(self.tx/self.bMEGA)

        return "%i Kb" %(self.tx/self.bKILO)

    def returnTransferredPack(self):
        ''' Returns transferred packages '''
        fileName = 'statistics/tx_packets'
        self.txp = int(file(os.path.join(self.class_path, self.device, fileName)).readline().strip())
        return int(self.txp)

    def returnReceivedPack(self):
        ''' Returns transferred packages '''
        fileName = 'statistics/rx_packets'
        self.rxp = int(file(os.path.join(self.class_path, self.device, fileName)).readline().strip())
        return int(self.rxp)


    def returnBrig(self):
        ''' Retorna brillo de pantalla '''
        fileName = '/sys/class/backlight/acpi_video0/brightness'
        self.brillo = int(file(os.path.join(fileName)).readline().strip())
        return int(self.brillo)

    def maxBrig(self):
        ''' Retorna brillo de pantalla '''
        fileName = '/sys/class/backlight/acpi_video0/max_brightness'
        self.brillomax = int(file(os.path.join(fileName)).readline().strip())
        return int(self.brillomax)
    def actBrig(self):
        ''' Retorna brillo de pantalla '''
        fileName = '/sys/class/backlight/acpi_video0/actual_brightness'
        self.brilloact = int(file(os.path.join(fileName)).readline().strip())
        return int(self.brilloact)

    def returnESSID(self):
        ''' Returns essid of interface '''
        buffer, structure = self.__packRequest(32)
        i, result = self.__readInformation(self.SIOCGIWESSID, structure)
        if i > 0:
            return result
        return buffer.tostring().strip('\x00')

    def datoend(self,nombre):
        global i
        global p
        encontrado=''
        while not encontrado:
           t = p[i].split(' ')
           if t[0].endswith(nombre):
               hola = p[i].find(':')
               encontrado = 'True'
           i = i + 1
        return p[i-1][hola + 2:]

    def datostart(self,nombre,s):
        global i
        encontrado = ''
        while not encontrado:
            t = p[i].split(' ')
            if t[s].startswith(nombre):
                hola = p[i].find(':')
                encontrado = 'True'
            i = i + 1
        return p[i-1][hola + 2:]

    def memdatostart(self,nombre,s,n,r):
        global i
        encontrado = ''
        while not encontrado:
            t = p[i].split(' ')
            if t[s].startswith(nombre):
                hola = p[i].find(':')
                tel = p[i][hola + 7 -r:hola + 14 + n]
                dato = float(tel)
                encontrado = 'True'
            i = i + 1
        return dato


    def returnBitrate(self):
        ''' Returns bit rate of interface '''
        i, result = self.__readInformation(self.SIOCGIWRATE)
        if i > 0:
            return result

        size = struct.calcsize('ihbb')
        m, e, i, pad = struct.unpack('ihbb', result[:size])
        if e == 0:
            bitrate =  m
        else:
            bitrate = float(m) * 10**e

        if bitrate >= self.wGIGA:
            return "%i Gb/s" %(bitrate/self.wGIGA)

        if bitrate >= self.wMEGA:
            return "%i Mb/s" %(bitrate/self.wMEGA)

        if bitrate >= self.wKILO:
            return "%i Kb/s" %(bitrate/self.wKILO)

    def returnMode(self):
        ''' Returns operation mode of interface '''
        i, result = self.__readInformation(self.SIOCGIWMODE)
        if i > 0:
            return result
        mode = self.__unpackRequest('i', result[:4])[0]
        return self.modes[mode]

    ''' Internal Methods '''

    def __packRequest(self, bufferSize):
        """ Packs wireless request data for sending it to the kernel """
        buffer = array.array('c', '\0' * bufferSize)
        caddr_t, length = buffer.buffer_info()
        structure = struct.pack('Pi', caddr_t, length)
        return buffer, structure

    def __unpackRequest(self, format, packedRequest):
        """ Unpacks request with given format """
        return struct.unpack(format, packedRequest)

    def __readInformation(self, request, data = None):
        ''' Read information from interface '''
        if data is not None:
            buffer = 16 - len(self.device)
            requestedInterface = self.device + '\0' * buffer
            requestedInterface += data
        else:
            requestedInterface = (self.device + '\0' * 32)
        try:
            result = fcntl.ioctl(self.sockfd.fileno(), request, requestedInterface)
        except IOError, (i, e):
            return i, e

        return (0, result[16:])

class DCOPIface(DCOPExObj):
    def __init__(self, wirelessStatusObject):
        ''' Constructor '''

        ''' Initialize DCOP ''' 
        DCOPExObj.__init__(self, "PyWirelessIface")

        self.wSO = wirelessStatusObject

        ''' DCOP functions '''
        self.addMethod("QString getInterfaceName()", self.getInterfaceName)
        self.addMethod("int getLinkStatus()", self.getLinkStatus)
        self.addMethod("int getNoiseStatus()", self.getNoiseStatus)
        self.addMethod("int getSignalStatus()", self.getSignalStatus)
        self.addMethod("QString getESSID()", self.getESSID)
        self.addMethod("QString getMode()", self.getMode)
        self.addMethod("QString returnReceived()", self.returnReceived)
        self.addMethod("QString returnTransferred()", self.returnTransferred)
        self.addMethod("int returnTransferredPack()", self.returnTransferredPack)
        self.addMethod("int returnReceivedPack()", self.returnReceivedPack)
        self.addMethod("int returnBrig()", self.returnBrig)
        self.addMethod("int maxBrig()", self.maxBrig)
        self.addMethod("int actBrig()", self.actBrig)
        self.addMethod("int changeMode()", self.changeMode)

    def getInterfaceName(self):
        return self.wSO.returnInterfaceName()

    def getLinkStatus(self):
        ''' Returns wireless link status % '''
        return self.wSO.returnLinkStatus()

    def getNoiseStatus(self):
        ''' Returns current noise level '''
        return self.wSO.returnNoiseStatus()

    def getSignalStatus(self):
        ''' Returns current signal level '''
        return self.wSO.returnSignalStatus()

    def getESSID(self):
        ''' Returns essid of interface '''
        return self.wSO.returnESSID()

    def getMode(self):
        ''' Returns operation mode of interface '''
        return self.wSO.returnMode()

    def returnReceived(self):
        ''' Returns received bytes '''
        return self.wSO.returnReceived()

    def returnTransferred(self):
        ''' Returns transferred bytes '''
        return self.wSO.returnTransferred()

    def returnTransferredPack(self):
        ''' Returns transferred packages '''
        return self.wSO.returnTransferredPack()

    def returnReceivedPack(self):
        ''' Returns transferred packages '''
        return self.wSO.returnReceivedPack()

    def returnBrig(self):
        ''' Returns transferred packages '''
        return self.wSO.returnBrig()
    def maxBrig(self):
        ''' Returns transferred packages '''
        return self.wSO.maxBrig()
    def actBrig(self):
        ''' Returns transferred packages '''
        return self.wSO.actBrig()
    def changeMode(self):
        return self.wSO.changeMode()

class SystemTray(KSystemTray):
    def __init__(self, *args):
        apply(KSystemTray.__init__, (self,) + args)

        ''' WirelessStatus instance '''
        self.wirelessStatus = WirelessStatus()

        ''' DCOP Interface ''' 
        self.DCOPInstance = DCOPIface(self.wirelessStatus)

        ''' Add /usr/share/PyWireless to KStandardDirs '''
        self.KStandardDirs =  KStandardDirs()
        self.KStandardDirs.addResourceDir("icon", "/usr/share/PyKDESystray")
        '''Add menu entrada click derecho de raton'''
        context_menu = self.contextMenu()
        context_menu.clear()
        self.icons = KIconLoader("pykdesystray", self.KStandardDirs)
        icono0 = self.icons.loadIcon("pykdesystray",KIcon.Panel, 32)
        context_menu.insertTitle(icono0, "PyKDESystray")
        icono1 = KGlobal.instance().iconLoader().loadIconSet("/usr/share/PyKDESystray/pykdesystray.png", KIcon.Panel, 22)
        context_menu.insertItem(icono1, "PyKDESystray", 1, 1)
        icono2 = KGlobal.instance().iconLoader().loadIconSet("/usr/share/PyKDESystray/pywireless_5.png", KIcon.Panel, 22)
        context_menu.insertItem(icono2, "Monitorear Wireless", 2, 2)
        icono3 = KGlobal.instance().iconLoader().loadIconSet("/usr/share/PyKDESystray/Monitor.png", KIcon.Panel, 22)
        context_menu.insertItem(icono3,"Monitorear Pantalla", 3, 3)
        icono4 = KGlobal.instance().iconLoader().loadIconSet("/usr/share/PyKDESystray/memory.png", KIcon.Panel, 22)
        context_menu.insertItem(icono4,"Monitorear CPU", 4, 4)
        icono5 = KGlobal.instance().iconLoader().loadIconSet("/usr/share/PyKDESystray/Memoria.png", KIcon.Panel, 22)
        context_menu.insertItem(icono5,"Monitorear Memoria", 5, 5)
        context_menu.connectItem(1, self.monitoreo)
        context_menu.connectItem(2, self.monitoreo)
        context_menu.connectItem(3, self.monitoreo)
        context_menu.connectItem(4, self.monitoreo)
        context_menu.connectItem(5, self.monitoreo)
        self.passive_popup = KPassivePopup(self)

        ''' Tray icon Loader '''
        if ( a == 0 ):
            self.icons = KIconLoader("PyWireless", self.KStandardDirs)

            ''' Load icon on startup '''
            self.setPixmap(self.icons.loadIcon('pywireless', KIcon.Desktop, 22)) 
        elif (a == 1):
            self.icons = KIconLoader("Monitor", self.KStandardDirs)
            self.setPixmap(self.icons.loadIcon('Monitor', KIcon.Desktop, 22))
            ''' Timer event triggered every 5 second
            Until i found a way to use inotify or libfam '''
	elif (a == 2):
	    self.icons = KIconLoader("memory", self.KStandardDirs)
            self.setPixmap(self.icons.loadIcon('memory', KIcon.Desktop, 22))
        else:
            self.icons = KIconLoader("Memoria", self.KStandardDirs)
            self.setPixmap(self.icons.loadIcon('Memoria', KIcon.Desktop, 22))
        self.time = QTimer(self)
        self.connect(self.time, SIGNAL('timeout()'), self.timeoutSlot)
        self.time.start(3000)
        self.installEventFilter(self)
        self.connect(app, SIGNAL("shutDown()"), self.slotQuit)

        self.show()

    def monitoreo(self, xa):
        global a
        if(xa == 1):
           '''Poner web currada'''
           QMessageBox.about(self,"Acerca de PyKDESystray 2.0","<P>Basado en el monitoreador PyQt/PyKDE <B>PyWireless</B></P>  <P>Desarrollado por:</P>  <P>Kaisermart pinciaes@yahoo.es</P>")
        else:
            a = xa - 2
            imodo = ["pywireless_5", "Monitor", "memory", "Memoria"]
            msg= ["Wireless", "Pantalla", "Cpu", "Memoria"]
            self.icons = KIconLoader(imodo[a], self.KStandardDirs)
            icono0 = self.icons.loadIcon(imodo[a],KIcon.Panel, 48)
            self.passive_popup.setTimeout(-1)
            self.passive_popup.message("PyKDESystray <img src=/usr/share/PyKDESystray/pykdesystray.png width=48 height=48 ALIGN=right>", "<P> Se ha cambiado al Modo <B>"+ msg[a] + "</B> con &eacute;xito.</P>",icono0, self)
            archivoconfiguracion(a)

    def slotQuit(self):
        self.deleteLater()
        app.quit()

    def timeoutSlot(self):
        global a
        status = self.wirelessStatus.returnInterfaceStatus()
        linkStatus = self.wirelessStatus.returnLinkStatus()
        if (a == 0) :
            interfaceName = self.wirelessStatus.returnInterfaceName()
            interfaceESSID = self.wirelessStatus.returnESSID()
            interfaceMode = self.wirelessStatus.returnMode()
            noiseStatus = self.wirelessStatus.returnNoiseStatus()
            signalStatus = self.wirelessStatus.returnSignalStatus()
            bitRate = self.wirelessStatus.returnBitrate()
            received = self.wirelessStatus.returnReceived()
            transferred = self.wirelessStatus.returnTransferred()
            transferredpack = self.wirelessStatus.returnTransferredPack()
            receivedpack = self.wirelessStatus.returnReceivedPack()
        elif (a == 1):
            brillito = self.wirelessStatus.returnBrig()
            brillomax = self.wirelessStatus.maxBrig()
            brilloact = self.wirelessStatus.actBrig()

        elif (a == 2):
            global i
            i = 0
            global p
            f = open('/proc/cpuinfo', 'r')
            p = f.readlines()
            f.close()
            cpu = self.wirelessStatus.datoend('model')
            frec1 = self.wirelessStatus.datostart('MHz',1)
            cache1 = self.wirelessStatus.datoend('cache')
            bogo1 = self.wirelessStatus.datostart('bogomips',0)
            lineas = len(p)
            i = lineas/2 + 0
            frec2 = self.wirelessStatus.datostart('MHz',1)
            cache2 = self.wirelessStatus.datoend('cache')
            bogo2 = self.wirelessStatus.datostart('bogomips',0)
            sa = float(frec1)/800

        else:
            i = 0
            f = open('/proc/meminfo', 'r')
            p = f.readlines()
            f.close()
            lineas = len(p)
            x = self.wirelessStatus.memdatostart('MemTotal', 0, 0, 0)
            x = str(x/(1024*1024))[:4]
            y = self.wirelessStatus.memdatostart('Active:', 0, 3, 0)
            y = str(y/(1024))[:6]
            z = self.wirelessStatus.memdatostart('Inactive:', 0, 1, 0)
            z = str(z/(1024))[:6]
            k = self.wirelessStatus.memdatostart('SwapTotal:', 0, 0, 1)
            k = str(k/(1024*1024))[:4]
            r = str(self.wirelessStatus.memdatostart('PageTables:', 0, -1, 1))[:4]

        if int(status):
            index = int(linkStatus) / 20
            iconName = 'pywireless_' + str(index)


            if (a == 0):
                ''' Tooltip '''
                toolTip = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png"></center>
                <center>
                    <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                    <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [ %s ]</b></center></td>
                <tr>
                    <td bgcolor="#CCCCCC"><b>ESSID:</b></td>
                    <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                    <td bgcolor="#EEEEEE"><b>Calidad del Enlace:</b></td>
                    <td bgcolor="#EEEEEE"><center>%d</center></td>
                </tr>
                <tr>
                    <td bgcolor="#CCCCCC"><b>Bit Rate:</b></td>
                    <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                    <td bgcolor="#EEEEEE"><b>Modo:</b></td>
                    <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Nivel de Ruido:</b></td>
                     <td bgcolor="#CCCCCC"><center>%d dBm</center></td>
                </tr>
                <tr>
                    <td bgcolor="#EEEEEE"><b>Nivel de Se&ntilde;al:</b></td>
                    <td bgcolor="#EEEEEE"><center>%d dBm</center></td>
                </tr>
                <tr>
                    <td bgcolor="#CCCCCC"><b>Recibido:</b></td>
                    <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Transferido:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                    <td bgcolor="#CCCCCC"><b>Paquetes Recibidos:</b></td>
                    <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                    <td bgcolor="#EEEEEE"><b>Paquetes Transferidos:</b></td>
                    <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                </table>
                </center>
                ''') % (iconName, interfaceName, interfaceESSID, linkStatus, bitRate, interfaceMode, noiseStatus, signalStatus, received, transferred, receivedpack, transferredpack)
                QToolTip.add(self, toolTip)
                self.setPixmap(self.icons.loadIcon(iconName, KIcon.Desktop, 22))
            elif (a == 1):
                indiceBrillo = int(brillito) / 10
                iconNameb = 'Monitor_' + str(indiceBrillo)
                tooltipb = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png" width="64" height="64"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                     <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [Pantalla Principal]</b></center></td>
                <tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Brillo:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Brillo M&aacute;ximo:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Brillo Actual:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                </table>
                </center>''') % ( iconNameb, brillito, brillomax, brilloact)
                QToolTip.add(self, tooltipb)
                self.icons = KIconLoader("Monitor", self.KStandardDirs)
                self.setPixmap(self.icons.loadIcon(iconNameb, KIcon.Desktop, 22))
            elif (a == 2):
                iconNamec = 'memory_'+ str(int(sa))
                tooltipc = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png" width="64" height="64"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                     <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [CPU]</b></center></td>
                <tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Modelo Cpu:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td colspan="2" bgcolor="#fcd30f"><center><b>N&uacute;cleo 1:</b></center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Frecuencia:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Cach&eacute;:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Bogomips:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td colspan="2" bgcolor="#fcd30f"><center><b>N&uacute;cleo 2:</b></center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Frecuencia:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Cach&eacute;:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Bogomips:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                </table>
                </center>''') % ( iconNamec, cpu, frec1, cache1, bogo1, frec2, cache2, bogo2)
                QToolTip.add(self, tooltipc)
                self.icons = KIconLoader("memory", self.KStandardDirs)
                self.setPixmap(self.icons.loadIcon(iconNamec, KIcon.Desktop, 22))
            else:
                iconNamed = 'Memoria'
                tooltipd = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png" width="64" height="64"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                     <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [Memoria]</b></center></td>
                <tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Memoria Total:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s GB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Memoria Activa:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s MB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Memoria Inactiva:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s MB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Tama&ntilde;o de Swap:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s GB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Tabla de p&aacute;gina:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s KB</center></td>
                </tr>
                </table>
                </center>''') % ( iconNamed, x, y, z, k, r)
                QToolTip.add(self, tooltipd)
                self.icons = KIconLoader("Memoria", self.KStandardDirs)
                self.setPixmap(self.icons.loadIcon(iconNamed, KIcon.Desktop, 22))

        else:
            if (a == 0):
                iconName = 'pywireless'
                toolTip = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                    <td colspan="2" bgcolor="#DD0500"><center>[ %s ] <b>est&aacute; apagado</b></center></td>
                </tr>
                </table>
                </center>''') % (iconName, interfaceName)
                QToolTip.add(self, toolTip)
                self.setPixmap(self.icons.loadIcon(iconName, KIcon.Desktop, 22))
            elif (a == 1):
                indiceBrillo = int(brillito) / 10
                iconNameb = 'Monitor_' + str(indiceBrillo)
                tooltipb = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                     <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [Pantalla Principal]</b></center></td>
                <tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Brillo:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Brillo M&aacute;ximo:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Brillo Actual:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                </table>
                </center>''') % ( iconNameb, brillito, brillomax, brilloact)
                QToolTip.add(self, tooltipb)
                self.icons = KIconLoader("Monitor", self.KStandardDirs)
                self.setPixmap(self.icons.loadIcon(iconNameb, KIcon.Desktop, 22))
            elif (a == 2):
                iconNamec = 'memory_'+ str(int(sa))
                tooltipc = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png" width="64" height="64"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                     <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [CPU]</b></center></td>
                <tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Modelo Cpu:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td colspan="2" bgcolor="#fcd30f"><center><b>N&uacute;cleo 1:</b></center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Frecuencia:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Cach&eacute;:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Bogomips:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td colspan="2" bgcolor="#fcd30f"><center><b>N&uacute;cleo 2:</b></center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Frecuencia:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Cach&eacute;:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Bogomips:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s</center></td>
                </tr>
                </table>
                </center>''') % ( iconNamec, cpu, frec1, cache1, bogo1, frec2, cache2, bogo2)
                QToolTip.add(self, tooltipc)
                self.icons = KIconLoader("memory", self.KStandardDirs)
                self.setPixmap(self.icons.loadIcon(iconNamec, KIcon.Desktop, 22))
            else:
                iconNamed = 'Memoria'
                tooltipd = _('''<center><img align="center" src="/usr/share/PyKDESystray/%s.png" width="64" height="64"></center>
                <center>
                <table border="0" bgcolor="#000000" cellspacing="1" cellpadding="1">
                <tr>
                     <td colspan="2" bgcolor="#04CC1A"><center><b>Monitoreando:</b> [Memoria]</b></center></td>
                <tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Memoria Total:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s GB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Memoria Activa:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s MB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Memoria Inactiva:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s MB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#EEEEEE"><b>Tama&ntilde;o de Swap:</b></td>
                     <td bgcolor="#EEEEEE"><center>%s GB</center></td>
                </tr>
                <tr>
                     <td bgcolor="#CCCCCC"><b>Tabla de p&aacute;gina:</b></td>
                     <td bgcolor="#CCCCCC"><center>%s KB</center></td>
                </tr>
                </table>
                </center>''') % ( iconNamed, x, y, z, k, r)
                QToolTip.add(self, tooltipd)
                self.icons = KIconLoader("Memoria", self.KStandardDirs)
                self.setPixmap(self.icons.loadIcon(iconNamed, KIcon.Desktop, 22))

    def eventFilter(self, object_, event):
        imodo = ["pywireless_5", "Monitor", "memory", "Memoria"]
        msg= ["Wireless", "Pantalla", "Cpu", "Memoria"]
        if (object_ == self
                and event.type() == QEvent.MouseButtonPress
                and event.button() == QEvent.LeftButton):
            global a
            if ( a == 0):
                a = 1
                archivoconfiguracion(a)

            elif (a == 1):
                a = 2
                archivoconfiguracion(a)

            elif (a == 2):
                a = 3
                archivoconfiguracion(a)

            else :
                a = 0
                archivoconfiguracion(a)
            self.icons = KIconLoader(imodo[a], self.KStandardDirs)
            icono0 = self.icons.loadIcon(imodo[a],KIcon.Panel, 48)
            self.passive_popup.setTimeout(-1)
            self.passive_popup.message("PyKDESystray <img src=/usr/share/PyKDESystray/pykdesystray.png width=48 height=48 ALIGN=right>", "<P> Se ha cambiado al Modo <B>"+ msg[a] + "</B> con &eacute;xito.</P>",icono0, self)
            return True

        return kdeui.KSystemTray.eventFilter(self, object_, event)

if __name__ == '__main__':
    appName = 'PyKDESystray'
    programName = 'PyKDESystray'
    description = 'Monitor basico Python'
    license = KAboutData.License_GPL
    version = '2.0'

    aboutData = KAboutData(appName, programName, version, description, license)
    aboutData.addAuthor('Kaisermart', 'PyKDESystray', 'pinciaes@yahoo.es')
    aboutData.addAuthor('S.Çağlar Onur', 'PyWireless Maintainer', 'caglar@uludag.org.tr')
    aboutData.addAuthor('Onur Küçük', 'PyWireless Contributor [Rx/Tx bytes part]', 'onur@uludag.org.tr')
    aboutData.addAuthor('Serdar Soytetir', 'PyWireless Contributor [New PyWireless Icons & UI Improvements]', 'sendirom@gmail.com')
    aboutData.addAuthor('Furkan Duman', 'PyWireless Contributor [Bug fix]', 'coderlord@yahoo.com')

    KCmdLineArgs.init(sys.argv, aboutData)
    KCmdLineArgs.addCmdLineOptions([('+files', 'File to open')])

    ''' Use KUniqueApplication and initialize'''
    gettext.install(appName)
    app = KUniqueApplication(True, True, True)
    trayWindow = SystemTray(None, appName)
    app.setMainWidget(trayWindow)

    ''' Enter main loop '''
    app.exec_loop()
